# coding: utf-8

# flake8: noqa
"""
    Emby Server REST API (BETA)
"""

from __future__ import absolute_import

# import models into model package
from emby_client.models.access_schedule import AccessSchedule
from emby_client.models.actions_postback_action import ActionsPostbackAction
from emby_client.models.activity_log_entry import ActivityLogEntry
from emby_client.models.album_info import AlbumInfo
from emby_client.models.all_theme_media_result import AllThemeMediaResult
from emby_client.models.api_available_recording_options import ApiAvailableRecordingOptions
from emby_client.models.api_base_items_request import ApiBaseItemsRequest
from emby_client.models.api_configuration_page_info import ApiConfigurationPageInfo
from emby_client.models.api_epg_row import ApiEpgRow
from emby_client.models.api_listing_provider_type_info import ApiListingProviderTypeInfo
from emby_client.models.api_name_id_description_pair import ApiNameIdDescriptionPair
from emby_client.models.api_on_playback_progress import ApiOnPlaybackProgress
from emby_client.models.api_set_channel_disabled import ApiSetChannelDisabled
from emby_client.models.api_set_channel_mapping import ApiSetChannelMapping
from emby_client.models.api_set_channel_sort_index import ApiSetChannelSortIndex
from emby_client.models.api_tag_item import ApiTagItem
from emby_client.models.artist_info import ArtistInfo
from emby_client.models.attributes_simple_condition import AttributesSimpleCondition
from emby_client.models.attributes_value_condition import AttributesValueCondition
from emby_client.models.authenticate_user import AuthenticateUser
from emby_client.models.authenticate_user_by_name import AuthenticateUserByName
from emby_client.models.authentication_authentication_result import AuthenticationAuthenticationResult
from emby_client.models.base_item_dto import BaseItemDto
from emby_client.models.base_item_person import BaseItemPerson
from emby_client.models.bit_rate import BitRate
from emby_client.models.book_info import BookInfo
from emby_client.models.branding_branding_options import BrandingBrandingOptions
from emby_client.models.channel_management_info import ChannelManagementInfo
from emby_client.models.chapter_info import ChapterInfo
from emby_client.models.client_capabilities import ClientCapabilities
from emby_client.models.codec_configuration import CodecConfiguration
from emby_client.models.codec_directions import CodecDirections
from emby_client.models.codec_kinds import CodecKinds
from emby_client.models.codec_profile import CodecProfile
from emby_client.models.codec_type import CodecType
from emby_client.models.collections_collection_creation_result import CollectionsCollectionCreationResult
from emby_client.models.color_formats import ColorFormats
from emby_client.models.common_editor_types import CommonEditorTypes
from emby_client.models.common_interfaces_i_codec_device_capabilities import CommonInterfacesICodecDeviceCapabilities
from emby_client.models.common_interfaces_i_codec_device_info import CommonInterfacesICodecDeviceInfo
from emby_client.models.common_plugins_i_plugin import CommonPluginsIPlugin
from emby_client.models.conditions_property_condition import ConditionsPropertyCondition
from emby_client.models.conditions_property_condition_type import ConditionsPropertyConditionType
from emby_client.models.configuration_tone_mapping_tone_map_options_visibility import ConfigurationToneMappingToneMapOptionsVisibility
from emby_client.models.connect_connect_authentication_exchange_result import ConnectConnectAuthenticationExchangeResult
from emby_client.models.connect_user_link_result import ConnectUserLinkResult
from emby_client.models.connect_user_link_type import ConnectUserLinkType
from emby_client.models.container_profile import ContainerProfile
from emby_client.models.create_user_by_name import CreateUserByName
from emby_client.models.day_of_week import DayOfWeek
from emby_client.models.default_directory_browser_info import DefaultDirectoryBrowserInfo
from emby_client.models.device_profile import DeviceProfile
from emby_client.models.devices_content_upload_history import DevicesContentUploadHistory
from emby_client.models.devices_device_info import DevicesDeviceInfo
from emby_client.models.devices_device_options import DevicesDeviceOptions
from emby_client.models.devices_local_file_info import DevicesLocalFileInfo
from emby_client.models.direct_play_profile import DirectPlayProfile
from emby_client.models.display_preferences import DisplayPreferences
from emby_client.models.dlna_profile_type import DlnaProfileType
from emby_client.models.dlna_profiles_device_identification import DlnaProfilesDeviceIdentification
from emby_client.models.dlna_profiles_device_profile_type import DlnaProfilesDeviceProfileType
from emby_client.models.dlna_profiles_dlna_profile import DlnaProfilesDlnaProfile
from emby_client.models.dlna_profiles_header_match_type import DlnaProfilesHeaderMatchType
from emby_client.models.dlna_profiles_http_header_info import DlnaProfilesHttpHeaderInfo
from emby_client.models.dlna_profiles_protocol_info_detection import DlnaProfilesProtocolInfoDetection
from emby_client.models.drawing_image_orientation import DrawingImageOrientation
from emby_client.models.dynamic_day_of_week import DynamicDayOfWeek
from emby_client.models.edit_object_container import EditObjectContainer
from emby_client.models.editors_editor_base import EditorsEditorBase
from emby_client.models.editors_editor_button_item import EditorsEditorButtonItem
from emby_client.models.editors_editor_root import EditorsEditorRoot
from emby_client.models.encoding_context import EncodingContext
from emby_client.models.enums_ui_command_type import EnumsUICommandType
from emby_client.models.enums_ui_view_type import EnumsUIViewType
from emby_client.models.extended_video_sub_types import ExtendedVideoSubTypes
from emby_client.models.extended_video_types import ExtendedVideoTypes
from emby_client.models.external_id_info import ExternalIdInfo
from emby_client.models.external_url import ExternalUrl
from emby_client.models.feature_info import FeatureInfo
from emby_client.models.feature_type import FeatureType
from emby_client.models.forgot_password import ForgotPassword
from emby_client.models.forgot_password_action import ForgotPasswordAction
from emby_client.models.forgot_password_pin import ForgotPasswordPin
from emby_client.models.forgot_password_result import ForgotPasswordResult
from emby_client.models.game_info import GameInfo
from emby_client.models.general_command import GeneralCommand
from emby_client.models.generic_edit_i_edit_object_container import GenericEditIEditObjectContainer
from emby_client.models.get_directory_contents import GetDirectoryContents
from emby_client.models.globalization_country_info import GlobalizationCountryInfo
from emby_client.models.globalization_culture_dto import GlobalizationCultureDto
from emby_client.models.globalization_localizaton_option import GlobalizationLocalizatonOption
from emby_client.models.io_file_system_entry_info import IOFileSystemEntryInfo
from emby_client.models.io_file_system_entry_type import IOFileSystemEntryType
from emby_client.models.image_info import ImageInfo
from emby_client.models.image_option import ImageOption
from emby_client.models.image_provider_info import ImageProviderInfo
from emby_client.models.image_saving_convention import ImageSavingConvention
from emby_client.models.image_type import ImageType
from emby_client.models.images_base_download_remote_image import ImagesBaseDownloadRemoteImage
from emby_client.models.installation_info import InstallationInfo
from emby_client.models.item_counts import ItemCounts
from emby_client.models.item_file_info import ItemFileInfo
from emby_client.models.item_file_type import ItemFileType
from emby_client.models.item_lookup_info import ItemLookupInfo
from emby_client.models.level_information import LevelInformation
from emby_client.models.library_add_media_path import LibraryAddMediaPath
from emby_client.models.library_add_virtual_folder import LibraryAddVirtualFolder
from emby_client.models.library_delete_info import LibraryDeleteInfo
from emby_client.models.library_item_link_type import LibraryItemLinkType
from emby_client.models.library_media_folder import LibraryMediaFolder
from emby_client.models.library_media_update_info import LibraryMediaUpdateInfo
from emby_client.models.library_option_info import LibraryOptionInfo
from emby_client.models.library_options import LibraryOptions
from emby_client.models.library_options_result import LibraryOptionsResult
from emby_client.models.library_post_updated_media import LibraryPostUpdatedMedia
from emby_client.models.library_remove_media_path import LibraryRemoveMediaPath
from emby_client.models.library_remove_virtual_folder import LibraryRemoveVirtualFolder
from emby_client.models.library_rename_virtual_folder import LibraryRenameVirtualFolder
from emby_client.models.library_sub_folder import LibrarySubFolder
from emby_client.models.library_type_options import LibraryTypeOptions
from emby_client.models.library_update_library_options import LibraryUpdateLibraryOptions
from emby_client.models.library_update_media_path import LibraryUpdateMediaPath
from emby_client.models.library_user_copy_options import LibraryUserCopyOptions
from emby_client.models.live_stream_request import LiveStreamRequest
from emby_client.models.live_stream_response import LiveStreamResponse
from emby_client.models.live_tv_channel_type import LiveTvChannelType
from emby_client.models.live_tv_guide_info import LiveTvGuideInfo
from emby_client.models.live_tv_keep_until import LiveTvKeepUntil
from emby_client.models.live_tv_keyword_info import LiveTvKeywordInfo
from emby_client.models.live_tv_keyword_type import LiveTvKeywordType
from emby_client.models.live_tv_listings_provider_info import LiveTvListingsProviderInfo
from emby_client.models.live_tv_live_tv_info import LiveTvLiveTvInfo
from emby_client.models.live_tv_recording_status import LiveTvRecordingStatus
from emby_client.models.live_tv_series_timer_info import LiveTvSeriesTimerInfo
from emby_client.models.live_tv_series_timer_info_dto import LiveTvSeriesTimerInfoDto
from emby_client.models.live_tv_timer_info_dto import LiveTvTimerInfoDto
from emby_client.models.live_tv_timer_type import LiveTvTimerType
from emby_client.models.live_tv_tuner_host_info import LiveTvTunerHostInfo
from emby_client.models.location_type import LocationType
from emby_client.models.log_file import LogFile
from emby_client.models.logging_log_severity import LoggingLogSeverity
from emby_client.models.mb_backup_api_all_backups_info import MBBackupApiAllBackupsInfo
from emby_client.models.mb_backup_api_data_restore_options import MBBackupApiDataRestoreOptions
from emby_client.models.mb_backup_api_restore_options import MBBackupApiRestoreOptions
from emby_client.models.mb_backup_api_user_restore_info import MBBackupApiUserRestoreInfo
from emby_client.models.mb_backup_backup_info import MBBackupBackupInfo
from emby_client.models.marker_type import MarkerType
from emby_client.models.media_encoding_codec_parameter_context import MediaEncodingCodecParameterContext
from emby_client.models.media_path_info import MediaPathInfo
from emby_client.models.media_protocol import MediaProtocol
from emby_client.models.media_source_info import MediaSourceInfo
from emby_client.models.media_source_type import MediaSourceType
from emby_client.models.media_stream import MediaStream
from emby_client.models.media_stream_type import MediaStreamType
from emby_client.models.media_url import MediaUrl
from emby_client.models.metadata_editor_info import MetadataEditorInfo
from emby_client.models.metadata_features import MetadataFeatures
from emby_client.models.metadata_fields import MetadataFields
from emby_client.models.metadata_refresh_mode import MetadataRefreshMode
from emby_client.models.movie_info import MovieInfo
from emby_client.models.music_video_info import MusicVideoInfo
from emby_client.models.name_id_pair import NameIdPair
from emby_client.models.name_long_id_pair import NameLongIdPair
from emby_client.models.name_value_pair import NameValuePair
from emby_client.models.net_end_point_info import NetEndPointInfo
from emby_client.models.net_sockets_address_family import NetSocketsAddressFamily
from emby_client.models.notification_category_info import NotificationCategoryInfo
from emby_client.models.notification_type_info import NotificationTypeInfo
from emby_client.models.operating_system import OperatingSystem
from emby_client.models.package_info import PackageInfo
from emby_client.models.package_target_system import PackageTargetSystem
from emby_client.models.package_version_class import PackageVersionClass
from emby_client.models.package_version_info import PackageVersionInfo
from emby_client.models.parental_rating import ParentalRating
from emby_client.models.path_substitution import PathSubstitution
from emby_client.models.persistence_intro_debug_info import PersistenceIntroDebugInfo
from emby_client.models.person_lookup_info import PersonLookupInfo
from emby_client.models.person_type import PersonType
from emby_client.models.pin_redeem_result import PinRedeemResult
from emby_client.models.play_command import PlayCommand
from emby_client.models.play_method import PlayMethod
from emby_client.models.play_request import PlayRequest
from emby_client.models.playback_error_code import PlaybackErrorCode
from emby_client.models.playback_info_request import PlaybackInfoRequest
from emby_client.models.playback_info_response import PlaybackInfoResponse
from emby_client.models.playback_progress_info import PlaybackProgressInfo
from emby_client.models.playback_start_info import PlaybackStartInfo
from emby_client.models.playback_stop_info import PlaybackStopInfo
from emby_client.models.player_state_info import PlayerStateInfo
from emby_client.models.playlists_add_to_playlist_info import PlaylistsAddToPlaylistInfo
from emby_client.models.playlists_add_to_playlist_result import PlaylistsAddToPlaylistResult
from emby_client.models.playlists_playlist_creation_result import PlaylistsPlaylistCreationResult
from emby_client.models.playstate_command import PlaystateCommand
from emby_client.models.playstate_request import PlaystateRequest
from emby_client.models.plugins_configuration_page_type import PluginsConfigurationPageType
from emby_client.models.plugins_plugin_info import PluginsPluginInfo
from emby_client.models.process_run_metrics_process_metric_point import ProcessRunMetricsProcessMetricPoint
from emby_client.models.process_run_metrics_process_statistics import ProcessRunMetricsProcessStatistics
from emby_client.models.profile_condition import ProfileCondition
from emby_client.models.profile_condition_type import ProfileConditionType
from emby_client.models.profile_condition_value import ProfileConditionValue
from emby_client.models.profile_information import ProfileInformation
from emby_client.models.profile_level_information import ProfileLevelInformation
from emby_client.models.progress_event import ProgressEvent
from emby_client.models.provider_id_dictionary import ProviderIdDictionary
from emby_client.models.proxy_header_mode import ProxyHeaderMode
from emby_client.models.public_system_info import PublicSystemInfo
from emby_client.models.query_result_activity_log_entry import QueryResultActivityLogEntry
from emby_client.models.query_result_api_epg_row import QueryResultApiEpgRow
from emby_client.models.query_result_base_item_dto import QueryResultBaseItemDto
from emby_client.models.query_result_channel_management_info import QueryResultChannelManagementInfo
from emby_client.models.query_result_devices_device_info import QueryResultDevicesDeviceInfo
from emby_client.models.query_result_live_tv_series_timer_info_dto import QueryResultLiveTvSeriesTimerInfoDto
from emby_client.models.query_result_live_tv_timer_info_dto import QueryResultLiveTvTimerInfoDto
from emby_client.models.query_result_log_file import QueryResultLogFile
from emby_client.models.query_result_string import QueryResultString
from emby_client.models.query_result_sync_job import QueryResultSyncJob
from emby_client.models.query_result_sync_job_item import QueryResultSyncJobItem
from emby_client.models.query_result_user_dto import QueryResultUserDto
from emby_client.models.query_result_user_library_official_rating_item import QueryResultUserLibraryOfficialRatingItem
from emby_client.models.query_result_user_library_tag_item import QueryResultUserLibraryTagItem
from emby_client.models.query_result_virtual_folder_info import QueryResultVirtualFolderInfo
from emby_client.models.queue_item import QueueItem
from emby_client.models.rating_type import RatingType
from emby_client.models.recommendation_dto import RecommendationDto
from emby_client.models.recommendation_type import RecommendationType
from emby_client.models.remote_image_info import RemoteImageInfo
from emby_client.models.remote_image_result import RemoteImageResult
from emby_client.models.remote_search_query_album_info import RemoteSearchQueryAlbumInfo
from emby_client.models.remote_search_query_artist_info import RemoteSearchQueryArtistInfo
from emby_client.models.remote_search_query_book_info import RemoteSearchQueryBookInfo
from emby_client.models.remote_search_query_game_info import RemoteSearchQueryGameInfo
from emby_client.models.remote_search_query_item_lookup_info import RemoteSearchQueryItemLookupInfo
from emby_client.models.remote_search_query_movie_info import RemoteSearchQueryMovieInfo
from emby_client.models.remote_search_query_music_video_info import RemoteSearchQueryMusicVideoInfo
from emby_client.models.remote_search_query_person_lookup_info import RemoteSearchQueryPersonLookupInfo
from emby_client.models.remote_search_query_series_info import RemoteSearchQuerySeriesInfo
from emby_client.models.remote_search_query_trailer_info import RemoteSearchQueryTrailerInfo
from emby_client.models.remote_search_result import RemoteSearchResult
from emby_client.models.remote_subtitle_info import RemoteSubtitleInfo
from emby_client.models.repeat_mode import RepeatMode
from emby_client.models.resolution import Resolution
from emby_client.models.resolution_with_rate import ResolutionWithRate
from emby_client.models.response_profile import ResponseProfile
from emby_client.models.roku_metadata_api_thumbnail_info import RokuMetadataApiThumbnailInfo
from emby_client.models.roku_metadata_api_thumbnail_set_info import RokuMetadataApiThumbnailSetInfo
from emby_client.models.run_ui_command import RunUICommand
from emby_client.models.secondary_frameworks import SecondaryFrameworks
from emby_client.models.segment_skip_mode import SegmentSkipMode
from emby_client.models.series_display_order import SeriesDisplayOrder
from emby_client.models.series_info import SeriesInfo
from emby_client.models.server_configuration import ServerConfiguration
from emby_client.models.session_session_info import SessionSessionInfo
from emby_client.models.session_user_info import SessionUserInfo
from emby_client.models.song_info import SongInfo
from emby_client.models.sort_order import SortOrder
from emby_client.models.subtitle_delivery_method import SubtitleDeliveryMethod
from emby_client.models.subtitle_location_type import SubtitleLocationType
from emby_client.models.subtitle_playback_mode import SubtitlePlaybackMode
from emby_client.models.subtitle_profile import SubtitleProfile
from emby_client.models.subtitles_subtitle_download_result import SubtitlesSubtitleDownloadResult
from emby_client.models.sync_category import SyncCategory
from emby_client.models.sync_data_request import SyncDataRequest
from emby_client.models.sync_data_response import SyncDataResponse
from emby_client.models.sync_dialog_options import SyncDialogOptions
from emby_client.models.sync_job import SyncJob
from emby_client.models.sync_job_creation_result import SyncJobCreationResult
from emby_client.models.sync_job_item import SyncJobItem
from emby_client.models.sync_job_item_status import SyncJobItemStatus
from emby_client.models.sync_job_option import SyncJobOption
from emby_client.models.sync_job_request import SyncJobRequest
from emby_client.models.sync_job_status import SyncJobStatus
from emby_client.models.sync_profile_option import SyncProfileOption
from emby_client.models.sync_quality_option import SyncQualityOption
from emby_client.models.sync_target import SyncTarget
from emby_client.models.synced_item import SyncedItem
from emby_client.models.synced_item_progress import SyncedItemProgress
from emby_client.models.system_event import SystemEvent
from emby_client.models.system_info import SystemInfo
from emby_client.models.task_completion_status import TaskCompletionStatus
from emby_client.models.task_info import TaskInfo
from emby_client.models.task_result import TaskResult
from emby_client.models.task_state import TaskState
from emby_client.models.task_trigger_info import TaskTriggerInfo
from emby_client.models.theme_media_result import ThemeMediaResult
from emby_client.models.trailer_info import TrailerInfo
from emby_client.models.transcode_reason import TranscodeReason
from emby_client.models.transcode_seek_info import TranscodeSeekInfo
from emby_client.models.transcoding_info import TranscodingInfo
from emby_client.models.transcoding_profile import TranscodingProfile
from emby_client.models.transcoding_vp_step_info import TranscodingVpStepInfo
from emby_client.models.transcoding_vp_step_types import TranscodingVpStepTypes
from emby_client.models.transport_stream_timestamp import TransportStreamTimestamp
from emby_client.models.tuple_double_double import TupleDoubleDouble
from emby_client.models.type_options import TypeOptions
from emby_client.models.ui_command import UICommand
from emby_client.models.ui_tab_page_info import UITabPageInfo
from emby_client.models.ui_view_info import UIViewInfo
from emby_client.models.unrated_item import UnratedItem
from emby_client.models.update_user_password import UpdateUserPassword
from emby_client.models.user_action import UserAction
from emby_client.models.user_action_type import UserActionType
from emby_client.models.user_configuration import UserConfiguration
from emby_client.models.user_dto import UserDto
from emby_client.models.user_item_data_dto import UserItemDataDto
from emby_client.models.user_item_share_level import UserItemShareLevel
from emby_client.models.user_library_add_tags import UserLibraryAddTags
from emby_client.models.user_library_leave_shared_items import UserLibraryLeaveSharedItems
from emby_client.models.user_library_official_rating_item import UserLibraryOfficialRatingItem
from emby_client.models.user_library_remove_tags import UserLibraryRemoveTags
from emby_client.models.user_library_tag_item import UserLibraryTagItem
from emby_client.models.user_library_update_user_item_access import UserLibraryUpdateUserItemAccess
from emby_client.models.user_notification_info import UserNotificationInfo
from emby_client.models.user_policy import UserPolicy
from emby_client.models.validate_path import ValidatePath
from emby_client.models.version import Version
from emby_client.models.video3_d_format import Video3DFormat
from emby_client.models.video_codec_base import VideoCodecBase
from emby_client.models.video_media_types import VideoMediaTypes
from emby_client.models.virtual_folder_info import VirtualFolderInfo
from emby_client.models.wake_on_lan_info import WakeOnLanInfo
